diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc ns-3.43/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc
--- ns-3.42/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/rate-control/minstrel-ht-wifi-manager.cc	2024-10-09 16:41:10.124656700 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2009 Duy Nguyen
  * Copyright (c) 2015 Ghada Badawy
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Duy Nguyen <duy@soe.ucsc.edu>
  *          Ghada Badawy <gbadawy@gmail.com>
@@ -228,16 +217,17 @@
     if (GetHtSupported())
     {
         // Initialize all HT groups
-        for (uint16_t chWidth = 20; chWidth <= MAX_HT_WIDTH; chWidth *= 2)
+        for (MHz_u chWidth = 20; chWidth <= MAX_HT_WIDTH; chWidth *= 2)
         {
             for (int gi = 800; gi >= 400;)
             {
+                const auto guardInterval = NanoSeconds(gi);
                 for (uint8_t streams = 1; streams <= MAX_HT_SUPPORTED_STREAMS; streams++)
                 {
-                    uint8_t groupId = GetHtGroupId(streams, gi, chWidth);
+                    uint8_t groupId = GetHtGroupId(streams, guardInterval, chWidth);
 
                     m_minstrelGroups[groupId].streams = streams;
-                    m_minstrelGroups[groupId].gi = gi;
+                    m_minstrelGroups[groupId].gi = guardInterval;
                     m_minstrelGroups[groupId].chWidth = chWidth;
                     m_minstrelGroups[groupId].type = WIFI_MINSTREL_GROUP_HT;
                     m_minstrelGroups[groupId].isSupported = false;
@@ -262,7 +252,7 @@
                                                mode,
                                                CalculateMpduTxDuration(GetPhy(),
                                                                        streams,
-                                                                       gi,
+                                                                       guardInterval,
                                                                        chWidth,
                                                                        mode,
                                                                        FIRST_MPDU_IN_AGGREGATE));
@@ -270,13 +260,14 @@
                                           mode,
                                           CalculateMpduTxDuration(GetPhy(),
                                                                   streams,
-                                                                  gi,
+                                                                  guardInterval,
                                                                   chWidth,
                                                                   mode,
                                                                   MIDDLE_MPDU_IN_AGGREGATE));
                         }
                         NS_LOG_DEBUG("Initialized group " << +groupId << ": (" << +streams << ","
-                                                          << gi << "," << chWidth << ")");
+                                                          << guardInterval << "," << chWidth
+                                                          << ")");
                     }
                 }
                 gi /= 2;
@@ -287,16 +278,17 @@
     if (GetVhtSupported())
     {
         // Initialize all VHT groups
-        for (uint16_t chWidth = 20; chWidth <= MAX_VHT_WIDTH; chWidth *= 2)
+        for (MHz_u chWidth = 20; chWidth <= MAX_VHT_WIDTH; chWidth *= 2)
         {
             for (int gi = 800; gi >= 400;)
             {
+                const auto guardInterval = NanoSeconds(gi);
                 for (uint8_t streams = 1; streams <= MAX_VHT_SUPPORTED_STREAMS; streams++)
                 {
-                    uint8_t groupId = GetVhtGroupId(streams, gi, chWidth);
+                    uint8_t groupId = GetVhtGroupId(streams, guardInterval, chWidth);
 
                     m_minstrelGroups[groupId].streams = streams;
-                    m_minstrelGroups[groupId].gi = gi;
+                    m_minstrelGroups[groupId].gi = guardInterval;
                     m_minstrelGroups[groupId].chWidth = chWidth;
                     m_minstrelGroups[groupId].type = WIFI_MINSTREL_GROUP_VHT;
                     m_minstrelGroups[groupId].isSupported = false;
@@ -324,7 +316,7 @@
                                     mode,
                                     CalculateMpduTxDuration(GetPhy(),
                                                             streams,
-                                                            gi,
+                                                            guardInterval,
                                                             chWidth,
                                                             mode,
                                                             FIRST_MPDU_IN_AGGREGATE));
@@ -332,7 +324,7 @@
                                               mode,
                                               CalculateMpduTxDuration(GetPhy(),
                                                                       streams,
-                                                                      gi,
+                                                                      guardInterval,
                                                                       chWidth,
                                                                       mode,
                                                                       MIDDLE_MPDU_IN_AGGREGATE));
@@ -350,22 +342,24 @@
     if (GetHeSupported())
     {
         // Initialize all HE groups
-        for (uint16_t chWidth = 20; chWidth <= MAX_HE_WIDTH; chWidth *= 2)
+        for (MHz_u chWidth = 20; chWidth <= MAX_HE_WIDTH; chWidth *= 2)
         {
             for (int gi = 3200; gi >= 800;)
             {
+                const auto guardInterval = NanoSeconds(gi);
                 for (uint8_t streams = 1; streams <= MAX_HE_SUPPORTED_STREAMS; streams++)
                 {
-                    uint8_t groupId = GetHeGroupId(streams, gi, chWidth);
+                    uint8_t groupId = GetHeGroupId(streams, guardInterval, chWidth);
 
                     m_minstrelGroups[groupId].streams = streams;
-                    m_minstrelGroups[groupId].gi = gi;
+                    m_minstrelGroups[groupId].gi = guardInterval;
                     m_minstrelGroups[groupId].chWidth = chWidth;
                     m_minstrelGroups[groupId].type = WIFI_MINSTREL_GROUP_HE;
                     m_minstrelGroups[groupId].isSupported = false;
 
                     // Check capabilities of the device
-                    if ((GetGuardInterval() <= gi) /// Is GI supported by the transmitter?
+                    if ((GetGuardInterval() <=
+                         guardInterval) /// Is GI supported by the transmitter?
                         && (GetPhy()->GetChannelWidth() >=
                             chWidth) /// Is channel width supported by the transmitter?
                         && (GetPhy()->GetMaxSupportedTxSpatialStreams() >=
@@ -386,7 +380,7 @@
                                     mode,
                                     CalculateMpduTxDuration(GetPhy(),
                                                             streams,
-                                                            gi,
+                                                            guardInterval,
                                                             chWidth,
                                                             mode,
                                                             FIRST_MPDU_IN_AGGREGATE));
@@ -394,7 +388,7 @@
                                               mode,
                                               CalculateMpduTxDuration(GetPhy(),
                                                                       streams,
-                                                                      gi,
+                                                                      guardInterval,
                                                                       chWidth,
                                                                       mode,
                                                                       MIDDLE_MPDU_IN_AGGREGATE));
@@ -411,10 +405,7 @@
 }
 
 bool
-MinstrelHtWifiManager::IsValidMcs(Ptr<WifiPhy> phy,
-                                  uint8_t streams,
-                                  uint16_t chWidth,
-                                  WifiMode mode)
+MinstrelHtWifiManager::IsValidMcs(Ptr<WifiPhy> phy, uint8_t streams, MHz_u chWidth, WifiMode mode)
 {
     NS_LOG_FUNCTION(this << phy << +streams << chWidth << mode);
     WifiTxVector txvector;
@@ -427,8 +418,8 @@
 Time
 MinstrelHtWifiManager::CalculateMpduTxDuration(Ptr<WifiPhy> phy,
                                                uint8_t streams,
-                                               uint16_t gi,
-                                               uint16_t chWidth,
+                                               Time gi,
+                                               MHz_u chWidth,
                                                WifiMode mode,
                                                MpduType mpduType)
 {
@@ -641,7 +632,7 @@
                                       double ackSnr,
                                       WifiMode ackMode,
                                       double dataSnr,
-                                      uint16_t dataChannelWidth,
+                                      MHz_u dataChannelWidth,
                                       uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
@@ -653,14 +644,14 @@
         return;
     }
 
-    NS_LOG_DEBUG("DoReportDataOk m_txrate = "
-                 << station->m_txrate
-                 << ", attempt = " << station->m_minstrelTable[station->m_txrate].numRateAttempt
-                 << ", success = " << station->m_minstrelTable[station->m_txrate].numRateSuccess
-                 << " (before update).");
-
     if (!station->m_isHt)
     {
+        NS_LOG_DEBUG("DoReportDataOk m_txrate = "
+                     << station->m_txrate
+                     << ", attempt = " << station->m_minstrelTable[station->m_txrate].numRateAttempt
+                     << ", success = " << station->m_minstrelTable[station->m_txrate].numRateSuccess
+                     << " (before update).");
+
         station->m_minstrelTable[station->m_txrate].numRateSuccess++;
         station->m_minstrelTable[station->m_txrate].numRateAttempt++;
 
@@ -684,16 +675,25 @@
     {
         uint8_t rateId = GetRateId(station->m_txrate);
         uint8_t groupId = GetGroupId(station->m_txrate);
+
+        NS_LOG_DEBUG(
+            "DoReportDataOk m_txrate = "
+            << station->m_txrate
+            << ", attempt = " << station->m_groupsTable[groupId].m_ratesTable[rateId].numRateAttempt
+            << ", success = " << station->m_groupsTable[groupId].m_ratesTable[rateId].numRateSuccess
+            << " (before update).");
+
         station->m_groupsTable[groupId].m_ratesTable[rateId].numRateSuccess++;
         station->m_groupsTable[groupId].m_ratesTable[rateId].numRateAttempt++;
 
         UpdatePacketCounters(station, 1, 0);
 
-        NS_LOG_DEBUG("DoReportDataOk m_txrate = "
-                     << station->m_txrate
-                     << ", attempt = " << station->m_minstrelTable[station->m_txrate].numRateAttempt
-                     << ", success = " << station->m_minstrelTable[station->m_txrate].numRateSuccess
-                     << " (after update).");
+        NS_LOG_DEBUG(
+            "DoReportDataOk m_txrate = "
+            << station->m_txrate
+            << ", attempt = " << station->m_groupsTable[groupId].m_ratesTable[rateId].numRateAttempt
+            << ", success = " << station->m_groupsTable[groupId].m_ratesTable[rateId].numRateSuccess
+            << " (after update).");
 
         station->m_isSampling = false;
         station->m_sampleDeferred = false;
@@ -766,7 +766,7 @@
                                              uint16_t nFailedMpdus,
                                              double rxSnr,
                                              double dataSnr,
-                                             uint16_t dataChannelWidth,
+                                             MHz_u dataChannelWidth,
                                              uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << nSuccessfulMpdus << nFailedMpdus << rxSnr << dataSnr
@@ -963,7 +963,7 @@
 }
 
 uint16_t
-MinstrelHtWifiManager::UpdateRateAfterAllowedWidth(uint16_t txRate, uint16_t allowedWidth)
+MinstrelHtWifiManager::UpdateRateAfterAllowedWidth(uint16_t txRate, MHz_u allowedWidth)
 {
     NS_LOG_FUNCTION(this << txRate << allowedWidth);
 
@@ -977,11 +977,11 @@
     }
 
     NS_ASSERT(GetPhy()->GetDevice()->GetHtConfiguration() != nullptr);
-    NS_ASSERT(group.chWidth % 20 == 0);
+    NS_ASSERT(static_cast<uint16_t>(group.chWidth) % 20 == 0);
     // try halving the channel width and check if the group with the same number of
     // streams and same GI is supported, until either a supported group is found or
     // the width becomes lower than 20 MHz
-    uint16_t width = group.chWidth / 2;
+    auto width = group.chWidth / 2;
 
     while (width >= 20)
     {
@@ -1021,7 +1021,7 @@
 }
 
 WifiTxVector
-MinstrelHtWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
+MinstrelHtWifiManager::DoGetDataTxVector(WifiRemoteStation* st, MHz_u allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
     auto station = static_cast<MinstrelHtWifiRemoteStation*>(st);
@@ -1058,7 +1058,7 @@
     // Check consistency of rate selected.
     if (((group.type == WIFI_MINSTREL_GROUP_HE) && (group.gi < GetGuardInterval(station))) ||
         (((group.type == WIFI_MINSTREL_GROUP_HT) || (group.type == WIFI_MINSTREL_GROUP_VHT)) &&
-         (group.gi == 400) && !GetShortGuardIntervalSupported(station)) ||
+         (group.gi.GetNanoSeconds() == 400) && !GetShortGuardIntervalSupported(station)) ||
         (group.chWidth > GetChannelWidth(station)) ||
         (group.streams > GetNumberOfSupportedStreams(station)))
     {
@@ -1067,7 +1067,7 @@
                        << " Station capabilities: (" << GetNumberOfSupportedStreams(station) << ","
                        << ((group.type == WIFI_MINSTREL_GROUP_HE)
                                ? GetGuardInterval(station)
-                               : (GetShortGuardIntervalSupported(station) ? 400 : 800))
+                               : NanoSeconds(GetShortGuardIntervalSupported(station) ? 400 : 800))
                        << "," << GetChannelWidth(station) << ")");
     }
     WifiMode mode = GetMcsSupported(station, mcsIndex);
@@ -1164,7 +1164,7 @@
             rtsRate,
             GetDefaultTxPowerLevel(),
             GetPreambleForTransmission(rtsRate.GetModulationClass(), GetShortPreambleEnabled()),
-            800,
+            NanoSeconds(800),
             1,
             1,
             0,
@@ -1742,7 +1742,8 @@
             }
             if (((m_minstrelGroups[groupId].type == WIFI_MINSTREL_GROUP_HT) ||
                  (m_minstrelGroups[groupId].type == WIFI_MINSTREL_GROUP_VHT)) &&
-                (m_minstrelGroups[groupId].gi == 400) && !GetShortGuardIntervalSupported(station))
+                (m_minstrelGroups[groupId].gi.GetNanoSeconds() == 400) &&
+                !GetShortGuardIntervalSupported(station))
             {
                 // It is a SGI group but the receiver does not support SGI: skip
                 continue;
@@ -2108,20 +2109,20 @@
 }
 
 uint8_t
-MinstrelHtWifiManager::GetHtGroupId(uint8_t txstreams, uint16_t gi, uint16_t chWidth)
+MinstrelHtWifiManager::GetHtGroupId(uint8_t txstreams, Time guardInterval, MHz_u chWidth)
 {
-    NS_LOG_FUNCTION(this << +txstreams << gi << chWidth);
-    uint8_t giIndex = (gi == 400) ? 1 : 0;
+    NS_LOG_FUNCTION(this << +txstreams << guardInterval << chWidth);
+    uint8_t giIndex = (guardInterval.GetNanoSeconds() == 400) ? 1 : 0;
     uint8_t widthIndex = (chWidth == 40) ? 1 : 0;
     return (MAX_HT_SUPPORTED_STREAMS * 2 * widthIndex) + (MAX_HT_SUPPORTED_STREAMS * giIndex) +
            txstreams - 1;
 }
 
 uint8_t
-MinstrelHtWifiManager::GetVhtGroupId(uint8_t txstreams, uint16_t gi, uint16_t chWidth)
+MinstrelHtWifiManager::GetVhtGroupId(uint8_t txstreams, Time guardInterval, MHz_u chWidth)
 {
-    NS_LOG_FUNCTION(this << +txstreams << gi << chWidth);
-    uint8_t giIndex = (gi == 400) ? 1 : 0;
+    NS_LOG_FUNCTION(this << +txstreams << guardInterval << chWidth);
+    uint8_t giIndex = (guardInterval.GetNanoSeconds() == 400) ? 1 : 0;
     uint8_t widthIndex;
     if (chWidth == 160)
     {
@@ -2146,11 +2147,11 @@
 }
 
 uint8_t
-MinstrelHtWifiManager::GetHeGroupId(uint8_t txstreams, uint16_t gi, uint16_t chWidth)
+MinstrelHtWifiManager::GetHeGroupId(uint8_t txstreams, Time guardInterval, MHz_u chWidth)
 {
-    NS_LOG_FUNCTION(this << +txstreams << gi << chWidth);
+    NS_LOG_FUNCTION(this << +txstreams << guardInterval << chWidth);
     uint8_t giIndex;
-    if (gi == 800)
+    if (const auto gi = guardInterval.GetNanoSeconds(); gi == 800)
     {
         giIndex = 2;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/rate-control/minstrel-ht-wifi-manager.h ns-3.43/src/wifi/model/rate-control/minstrel-ht-wifi-manager.h
--- ns-3.42/src/wifi/model/rate-control/minstrel-ht-wifi-manager.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/rate-control/minstrel-ht-wifi-manager.h	2024-10-09 16:41:10.124656700 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2009 Duy Nguyen
  * Copyright (c) 2015 Ghada Badawy
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  *Authors: Duy Nguyen <duy@soe.ucsc.edu>
  *         Ghada Badawy <gbadawy@gmail.com>
@@ -27,8 +16,8 @@
 
 #include "minstrel-wifi-manager.h"
 
-#include "ns3/wifi-mpdu-type.h"
 #include "ns3/wifi-remote-station-manager.h"
+#include "ns3/wifi-types.h"
 
 namespace ns3
 {
@@ -81,8 +70,8 @@
 struct McsGroup
 {
     uint8_t streams;   ///< number of spatial streams
-    uint16_t gi;       ///< guard interval duration (nanoseconds)
-    uint16_t chWidth;  ///< channel width (MHz)
+    Time gi;           ///< guard interval duration
+    MHz_u chWidth;     ///< channel width
     McsGroupType type; ///< identifies the group, \see McsGroupType
     bool isSupported;  ///< flag whether group is  supported
     // To accurately account for TX times, we separate the TX time of the first
@@ -185,9 +174,9 @@
 static const uint8_t MAX_HT_GROUP_RATES = 8;   //!< Number of rates (or MCS) per HT group.
 static const uint8_t MAX_VHT_GROUP_RATES = 10; //!< Number of rates (or MCS) per VHT group.
 static const uint8_t MAX_HE_GROUP_RATES = 12;  //!< Number of rates (or MCS) per HE group.
-static const uint8_t MAX_HT_WIDTH = 40;        //!< Maximal channel width in MHz.
-static const uint8_t MAX_VHT_WIDTH = 160;      //!< Maximal channel width in MHz.
-static const uint8_t MAX_HE_WIDTH = 160;       //!< Maximal channel width in MHz.
+static const MHz_u MAX_HT_WIDTH = 40;          //!< Maximal channel width.
+static const MHz_u MAX_VHT_WIDTH = 160;        //!< Maximal channel width.
+static const MHz_u MAX_HE_WIDTH = 160;         //!< Maximal channel width.
 
 /**
  * \brief Implementation of Minstrel-HT Rate Control Algorithm
@@ -270,18 +259,18 @@
                         double ackSnr,
                         WifiMode ackMode,
                         double dataSnr,
-                        uint16_t dataChannelWidth,
+                        MHz_u dataChannelWidth,
                         uint8_t dataNss) override;
     void DoReportFinalRtsFailed(WifiRemoteStation* station) override;
     void DoReportFinalDataFailed(WifiRemoteStation* station) override;
-    WifiTxVector DoGetDataTxVector(WifiRemoteStation* station, uint16_t allowedWidth) override;
+    WifiTxVector DoGetDataTxVector(WifiRemoteStation* station, MHz_u allowedWidth) override;
     WifiTxVector DoGetRtsTxVector(WifiRemoteStation* station) override;
     void DoReportAmpduTxStatus(WifiRemoteStation* station,
                                uint16_t nSuccessfulMpdus,
                                uint16_t nFailedMpdus,
                                double rxSnr,
                                double dataSnr,
-                               uint16_t dataChannelWidth,
+                               MHz_u dataChannelWidth,
                                uint8_t dataNss) override;
     bool DoNeedRetransmission(WifiRemoteStation* st,
                               Ptr<const Packet> packet,
@@ -292,11 +281,11 @@
      *
      * \param phy pointer to the wifi PHY
      * \param streams the number of streams
-     * \param chWidth the channel width (MHz)
+     * \param chWidth the channel width
      * \param mode the wifi mode
      * \returns true if the combination is valid
      */
-    bool IsValidMcs(Ptr<WifiPhy> phy, uint8_t streams, uint16_t chWidth, WifiMode mode);
+    bool IsValidMcs(Ptr<WifiPhy> phy, uint8_t streams, MHz_u chWidth, WifiMode mode);
 
     /**
      * Estimates the TxTime of a frame with a given mode and group (stream, guard interval and
@@ -304,16 +293,16 @@
      *
      * \param phy pointer to the wifi PHY
      * \param streams the number of streams
-     * \param gi guard interval duration (nanoseconds)
-     * \param chWidth the channel width (MHz)
+     * \param gi guard interval duration
+     * \param chWidth the channel width
      * \param mode the wifi mode
      * \param mpduType the type of the MPDU
      * \returns the transmit time
      */
     Time CalculateMpduTxDuration(Ptr<WifiPhy> phy,
                                  uint8_t streams,
-                                 uint16_t gi,
-                                 uint16_t chWidth,
+                                 Time gi,
+                                 MHz_u chWidth,
                                  WifiMode mode,
                                  MpduType mpduType);
 
@@ -577,31 +566,31 @@
      * Returns the groupId of an HT MCS with the given number of streams, GI and channel width used.
      *
      * \param txstreams the number of streams
-     * \param gi guard interval duration (nanoseconds)
-     * \param chWidth the channel width (MHz)
+     * \param guardInterval guard interval duration
+     * \param chWidth the channel width
      * \returns the HT group ID
      */
-    uint8_t GetHtGroupId(uint8_t txstreams, uint16_t gi, uint16_t chWidth);
+    uint8_t GetHtGroupId(uint8_t txstreams, Time guardInterval, MHz_u chWidth);
 
     /**
      * Returns the groupId of a VHT MCS with the given number of streams, GI and channel width used.
      *
      * \param txstreams the number of streams
-     * \param gi guard interval duration (nanoseconds)
-     * \param chWidth the channel width (MHz)
+     * \param guardInterval guard interval duration
+     * \param chWidth the channel width
      * \returns the VHT group ID
      */
-    uint8_t GetVhtGroupId(uint8_t txstreams, uint16_t gi, uint16_t chWidth);
+    uint8_t GetVhtGroupId(uint8_t txstreams, Time guardInterval, MHz_u chWidth);
 
     /**
      * Returns the groupId of an HE MCS with the given number of streams, GI and channel width used.
      *
      * \param txstreams the number of streams
-     * \param gi guard interval duration (nanoseconds)
-     * \param chWidth the channel width (MHz)
+     * \param guardInterval guard interval duration
+     * \param chWidth the channel width
      * \returns the HE group ID
      */
-    uint8_t GetHeGroupId(uint8_t txstreams, uint16_t gi, uint16_t chWidth);
+    uint8_t GetHeGroupId(uint8_t txstreams, Time guardInterval, MHz_u chWidth);
 
     /**
      * Returns the lowest global index of the rates supported by the station.
@@ -648,11 +637,11 @@
      * found, the simulation aborts.
      *
      * \param txRate the index of the current TX rate
-     * \param allowedWidth the allowed width in MHz
+     * \param allowedWidth the allowed width
      * \return the index of a TX rate whose channel width is not greater than the
      *         allowed width, if found (otherwise, the simulation aborts)
      */
-    uint16_t UpdateRateAfterAllowedWidth(uint16_t txRate, uint16_t allowedWidth);
+    uint16_t UpdateRateAfterAllowedWidth(uint16_t txRate, MHz_u allowedWidth);
 
     Time m_updateStats;            //!< How frequent do we calculate the stats.
     Time m_legacyUpdateStats;      //!< How frequent do we calculate the stats for legacy
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/rate-control/minstrel-wifi-manager.cc ns-3.43/src/wifi/model/rate-control/minstrel-wifi-manager.cc
--- ns-3.42/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/rate-control/minstrel-wifi-manager.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 Duy Nguyen
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Duy Nguyen <duy@soe.ucsc.edu>
  *          Matías Richart <mrichart@fing.edu.uy>
@@ -385,7 +374,7 @@
 MinstrelWifiManager::GetDataTxVector(MinstrelWifiRemoteStation* station)
 {
     NS_LOG_FUNCTION(this << station);
-    uint16_t channelWidth = GetChannelWidth(station);
+    auto channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
         channelWidth = 20;
@@ -405,7 +394,7 @@
         mode,
         GetDefaultTxPowerLevel(),
         GetPreambleForTransmission(mode.GetModulationClass(), GetShortPreambleEnabled()),
-        800,
+        NanoSeconds(800),
         1,
         1,
         0,
@@ -418,7 +407,7 @@
 {
     NS_LOG_FUNCTION(this << station);
     NS_LOG_DEBUG("DoGetRtsMode m_txrate=" << station->m_txrate);
-    uint16_t channelWidth = GetChannelWidth(station);
+    auto channelWidth = GetChannelWidth(station);
     if (channelWidth > 20 && channelWidth != 22)
     {
         channelWidth = 20;
@@ -436,7 +425,7 @@
         mode,
         GetDefaultTxPowerLevel(),
         GetPreambleForTransmission(mode.GetModulationClass(), GetShortPreambleEnabled()),
-        800,
+        NanoSeconds(800),
         1,
         1,
         0,
@@ -818,7 +807,7 @@
                                     double ackSnr,
                                     WifiMode ackMode,
                                     double dataSnr,
-                                    uint16_t dataChannelWidth,
+                                    MHz_u dataChannelWidth,
                                     uint8_t dataNss)
 {
     NS_LOG_FUNCTION(this << st << ackSnr << ackMode << dataSnr << dataChannelWidth << +dataNss);
@@ -932,7 +921,7 @@
 }
 
 WifiTxVector
-MinstrelWifiManager::DoGetDataTxVector(WifiRemoteStation* st, uint16_t allowedWidth)
+MinstrelWifiManager::DoGetDataTxVector(WifiRemoteStation* st, MHz_u allowedWidth)
 {
     NS_LOG_FUNCTION(this << st << allowedWidth);
     auto station = static_cast<MinstrelWifiRemoteStation*>(st);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/rate-control/minstrel-wifi-manager.h ns-3.43/src/wifi/model/rate-control/minstrel-wifi-manager.h
--- ns-3.42/src/wifi/model/rate-control/minstrel-wifi-manager.h	2024-05-29 15:29:47.208073900 -0700
+++ ns-3.43/src/wifi/model/rate-control/minstrel-wifi-manager.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 Duy Nguyen
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Duy Nguyen <duy@soe.ucsc.edu>
  *          Matías Richart <mrichart@fing.edu.uy>
@@ -257,11 +246,11 @@
                         double ackSnr,
                         WifiMode ackMode,
                         double dataSnr,
-                        uint16_t dataChannelWidth,
+                        MHz_u dataChannelWidth,
                         uint8_t dataNss) override;
     void DoReportFinalRtsFailed(WifiRemoteStation* station) override;
     void DoReportFinalDataFailed(WifiRemoteStation* station) override;
-    WifiTxVector DoGetDataTxVector(WifiRemoteStation* station, uint16_t allowedWidth) override;
+    WifiTxVector DoGetDataTxVector(WifiRemoteStation* station, MHz_u allowedWidth) override;
     WifiTxVector DoGetRtsTxVector(WifiRemoteStation* station) override;
 
     bool DoNeedRetransmission(WifiRemoteStation* st,
